// Name.cpp: implementation of the CName class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "awana_grandprix_scoring.h"
#include "Name.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// symbols
//////////////////////////////////////////////////////////////////////

#define kSymbolDivider      "-----"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CName::CName() {

}

CName::~CName() {

}

//////////////////////////////////////////////////////////////////////
// public
//////////////////////////////////////////////////////////////////////

string CName::get(int pIndex) {
  if (mNames.find(pIndex) != mNames.end()) {
    return mNames[pIndex];
  }

  return "";
}

void CName::change(int pIndex, string pName) {
  if (mNames.find(pIndex) != mNames.end()) {
    mNames[pIndex] = pName;
  }
}

void CName::add(int pIndex, string pName) {
  mNames[pIndex] = pName;
}

void CName::remove(int pIndex) {
  mNames.erase(pIndex);
}

void CName::load(FILE* pFile) {
  // clear data structure
  mNames.clear();

  // load
  while (!feof(pFile)) {
    char theBuffer[1024];
    fgets(theBuffer, 1024, pFile);

    // process symbols
    if (strncmp(theBuffer, kSymbolDivider, strlen(kSymbolDivider)) == 0) {
      // after we get the divide, don't process anymore
      break;
    }

    // process data
    char theSeps[] = ",\n";
    char* theIDStr;
    char* theNameStr;

    theIDStr = strtok(theBuffer, theSeps);
    theNameStr = strtok(0, theSeps);

    // trim name
    char* theName = theNameStr;
    while ((theName[0] == ' ') || (theName[0] == '\t')) {
      theName++;
    }
    int theLength = strlen(theName);
    if (theLength > 0) {
      int theChar = theName[theLength-1];
      while ((theLength > 0) && ((theChar == ' ') || (theChar == '\t') || (theChar == '\n'))) {
        theName[theLength-1] = 0;
        theLength--;
        theChar = theName[theLength-1];
      }
    }

    // convert id
    int theID = atoi(theIDStr);

    // store
    mNames[theID] = theName;
  }
}

void CName::save(FILE* pFile) {
  // write contents out into file
  for (tIntStringMAP::const_iterator theIter = mNames.begin(); theIter != mNames.end(); theIter++) {
    fprintf(pFile, "%d, %s\n", theIter->first, theIter->second.c_str());
  }

  // write out the divider
  fprintf(pFile, "%s\n", kSymbolDivider);
}

