// Name.h: interface for the CName class.
// - name repository maps integer ids to names
// - format is <int>, <string>
//
//////////////////////////////////////////////////////////////////////

#ifndef __name_h__
#define __name_h__

#ifdef _MSC_VER
  // microsoft vc++ specific
  #pragma warning(disable:4786)
#endif

#include <map>
#include <string>

using namespace std;

#include <stdio.h>

class CState;

class CName {
  // friends
  friend CState;

  public:
	  CName();
	  virtual ~CName();

    // given an integer, map to a name
    string get(int pIndex);

    // change the name string for an integer
    void change(int pIndex, string pName);

    // add a name
    void add(int pIndex, string pName);

    // remove an integer
    void remove(int pIndex);

    // load from file
    void load(FILE* pFile);

    // save to file
    void save(FILE* pFile);

  protected:
    typedef map<int, string> tIntStringMAP;
    tIntStringMAP mNames;
};

#endif // __name_h__
